unit Unit1;

{$mode objfpc}{$H+}

{if you want a clean surface without example data and example controls enable
 the switch 'UseExampleCode' by removing the statement or comment it
 and everything what you dont need will be engrayed
 You also may therefore delete all Code enclosed in this define brackets
 including the define statements without any damage to the core framework

     {$ifdef UseExampleCode}
      ...any Code
    {$endif}

 }

{$DEFINE UseFrameExampleCode}  //<-- preferred example
{.$DEFINE UseExampleCode}

interface

uses
  Classes, SysUtils, DB, SQLDB, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, ExtCtrls, DBCtrls, ComCtrls, Buttons
  ,udmsqldb,fcredentials {$ifdef UseFrameExampleCode},frame_example1{$endif};

type

  { TForm1 }

  TForm1 = class(TForm)
    bttnManageCredentials: TBitBtn;
    comboConnectorType: TComboBox;
    DataSource1: TDataSource;
    Label1: TLabel;
    SQLQuery1: TSQLQuery;
    StatusBar1: TStatusBar;

    procedure comboConnectorTypeChange(Sender: TObject);
    procedure bttnManageCredentialsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private

  public

  end;

var
  Form1: TForm1;
  procedure CeckDataModuleAssigned;

implementation

procedure CeckDataModuleAssigned;
begin
  //Check if the datamodule exists before using it in case
  //someone forgot to put it to the first place
  //in the project options Auto-Create forms list
  //or had created it by sourcecode
  if not assigned(dmsqldb) then
    raise Exception.Create( LineEnding
                          + 'File: ' + {$INCLUDE %FILE%} + LineEnding
                          + 'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding
                          + 'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding +LineEnding
                          + 'The data module has not yet been created. Please note that the data module must be created '
                          + 'before the main form. Check the order of creation in the project options (Ctrl+Shift+F11) '
                          + 'under position forms '
                          + LineEnding
                          );
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CeckDataModuleAssigned;    //check if the datamodule already exists
  with comboConnectorType do //fill the combo box
  begin
    Items.AddDelimitedtext(GetDBconnectionsFromIni,';',true);
    text:=dmsqldb.prCredentials.section;
  end;

end;


procedure TForm1.FormActivate(Sender: TObject);
var
  OldCursor: TCursor;
  {$ifdef UseFrameExampleCode}
  fr:TFrameExample1;
  {$endif}
begin
  OldCursor:=Screen.Cursor;
  StatusBar1.SimpleText:='Please wait, database is created and prepared....';

  Screen.Cursor := crSQLWait;
  Application.ProcessMessages;
  try
    If dmsqldb.SQLConnector1.Connected then begin
      StatusBar1.SimpleText:='Database ready';
      {The most easiest way to migrate existing applications to this framework
       is similar to the use of frames.
       Create your man window by code and connect your queries to the new connection
       as shown in the following few lines.
       It does not matter if you do this with frames or full blown forms.
      }
      {$ifdef UseFrameExampleCode}
        fr := TFrameExample1.Create(self);
        fr.Parent := self;
        fr.Align:=alClient;
        fr.SQLQuery1.DataBase:=dmsqldb.SQLConnector1;
        fr.Initialize;
      {$endif}
    end
    else
      StatusBar1.SimpleText:='Database offline';

  finally
    Screen.Cursor:=OldCursor;
    Application.ProcessMessages;
  end;

  //Maybe your code goes here...

end;

procedure TForm1.comboConnectorTypeChange(Sender: TObject);
var
  s:string;
begin
  s:=comboConnectorType.Text;
  dmsqldb.ChangeConnection(s);
end;

procedure TForm1.bttnManageCredentialsClick(Sender: TObject);
var
  myForm:TfrmCredentials;
begin
  myForm:=TfrmCredentials.Create(self);
  myForm.ShowModal;
  myForm.Free;
end;

end.

