unit fcredentials;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, memds, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, DBCtrls, ActnList, ComCtrls;

const
  cEDIT=2;
  cBROWSE=1;
  cTOGGLE=0;

type

  { TfrmCredentials }

  TfrmCredentials = class(TForm)
    actn_SaveAllToIni: TAction;
    actn_SaveCurrentToIni: TAction;
    actn_GetStandardCredentials: TAction;
    actn_PrepareAsExample: TAction;
    actn_WriteStandardSectionToINI: TAction;
    actn_ReadStandardSectionToControls: TAction;
    actn_MakeConnectionDefault: TAction;
    actn_TestConnection: TAction;
    actn_ReadAllFromIni: TAction;
    ActionList1: TActionList;
    Button1: TButton;
    bttnSave: TButton;
    bttnMakeDefault: TButton;
    bttnGetStandardCredentials: TButton;
    bttnSaveAll: TButton;
    bttnTest: TButton;
    Button2: TButton;
    Button3: TButton;
    cbImportDemoDataOnCreate: TCheckBox;
    cbDeleteDatabasefileBeforeOpen: TCheckBox;
    cbChooseDatabaseOnStartup: TCheckBox;
    cbAllowOpenDialogOnSQLImportFile: TCheckBox;
    DataSource1: TDataSource;
    cbConnectionTypes: TDBComboBox;
    DBNavigator1: TDBNavigator;
    eSection: TDBEdit;
    eServer: TDBEdit;
    eDatabasename: TDBEdit;
    eUsername: TDBEdit;
    ePassword: TDBEdit;
    eCustomLibraryName: TDBEdit;
    eCaption: TDBEdit;
    DBGrid1: TDBGrid;
    Label10: TLabel;
    mDescription: TDBMemo;
    eSQLCustomImportFileName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    PageControl1: TPageControl;
    tsConnections: TTabSheet;
    TabSheet2: TTabSheet;
    TConnections: TMemDataset;

    procedure actn_GetStandardCredentialsExecute(Sender: TObject);
    procedure actn_MakeConnectionDefaultExecute(Sender: TObject);
    procedure actn_ReadAllFromIniExecute(Sender: TObject);
    procedure actn_ReadStandardSectionToControlsExecute(Sender: TObject);
    procedure actn_SaveAllToIniExecute(Sender: TObject);
    procedure actn_SaveCurrentToIniExecute(Sender: TObject);
    procedure actn_TestConnectionExecute(Sender: TObject);
    procedure actn_WriteStandardSectionToINIExecute(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TDBNavButtonType);
    procedure FormCreate(Sender: TObject);
    procedure TConnectionsBeforeDelete(DataSet: TDataSet);
  private
    FsIniFileName:string;
    function ReadIniToTConnections: boolean;
    procedure ReadStandardSectionToControls;
    procedure WriteStandardSectionToINI;
    procedure TestConnection;
    procedure ToggleControls(iHow:integer=0);
    procedure GetStandardCredentials;
    procedure MakeConnectionDefault;
    procedure SaveAllToIni;
  public
    procedure WriteCredentialsToIni(sSection:string);
    procedure DeleteCredentialFromIni(sSection:string);
  end;

var
  frmCredentials: TfrmCredentials;

implementation

{$R *.lfm}

uses
  uguessfile, inifiles, udmsqldb;

{ TfrmCredentials }

procedure TfrmCredentials.FormCreate(Sender: TObject);
begin
  ToggleControls(cBROWSE);
  PageControl1.ActivePage:=tsConnections;
  //FsIniFileName:= GuessDBIniFile;
  FsIniFileName:=dmsqldb.psIniFileName;

  TConnections.Open;

  cbConnectionTypes.Items.AddDelimitedtext(dmsqldb.ListConnectionTypes(false),';',true);

  ReadStandardSectionToControls;
  ReadIniToTConnections;
  TConnections.First;
end;

procedure TfrmCredentials.DBNavigator1Click(Sender: TObject;
  Button: TDBNavButtonType);
begin
  case Button of
  nbFirst :    begin
    end;
  nbPrior :    begin
    end;
  nbLast :    begin
    end;
  nbInsert :    begin
    ToggleControls(cEDIT);
    end;
  nbEdit :    begin
    ToggleControls(cEDIT);
    end;
  nbPost :    begin
    ToggleControls(cBROWSE);
  end;
  nbCancel :    begin
    ToggleControls(cBROWSE);
    end;
  nbDelete :    begin
    ToggleControls(cBROWSE);
    //showmessage(esection.text);
    //DeleteCredentialFromIni(eSection.text);
    //ReadIniToTConnections;
    end;
  nbRefresh:    begin
    ToggleControls(cBROWSE);
    ReadIniToTConnections;
    end;
  end; //case
end;




procedure TfrmCredentials.TestConnection;
begin

  // TODO write current data to ini
  dmsqldb.ChangeConnection(eSection.Text);

  ////dmsqldb.prCredentials:=GetCredentialsFromIniSection(eSection.Text,FsIniFileName);
  //dmsqldb.RefreshCredentials(eSection.Text);
  //dmsqldb.Initialize;
  //dmsqldb.OpenConnection;
  //If dmsqldb.SQLConnector1.Connected then
  //  showmessage('Connection established, Database ready')
  //else
  //  showmessage('Could not establish connection, Database offline');
end;

procedure TfrmCredentials.ToggleControls(iHow: integer);
begin
  case iHow of
    0: begin   //Toggle mode
      cbConnectionTypes.Enabled:=not cbConnectionTypes.Enabled;
      eSection.Enabled:=not eSection.Enabled;
      eServer.Enabled:=not eServer.Enabled;
      eDatabasename.Enabled:=not eDatabasename.Enabled;
      eUsername.Enabled:= not eUsername.Enabled;
      ePassword.Enabled:=not ePassword.Enabled;
      eCustomLibraryName.Enabled:=not eCustomLibraryName.Enabled;
      eCaption.Enabled:=not eCaption.Enabled;
      mDescription.Enabled:=not mDescription.Enabled;

      actn_GetStandardCredentials.Enabled:=not actn_GetStandardCredentials.Enabled;
      actn_MakeConnectionDefault.Enabled:=not actn_MakeConnectionDefault.Enabled;
      actn_TestConnection.Enabled:=not actn_TestConnection.Enabled;
      actn_ReadAllFromIni.Enabled:=not actn_ReadAllFromIni.Enabled;

      actn_SaveAllToIni.Enabled:=not actn_SaveAllToIni.Enabled;
      actn_SaveCurrentToIni.Enabled:=not actn_SaveCurrentToIni.Enabled;
   end ;
   1 : begin   //Browse Mode
     cbConnectionTypes.Enabled:=false;
     eSection.Enabled:=false;
     eServer.Enabled:=false;
     eDatabasename.Enabled:=false;
     eUsername.Enabled:= false;
     ePassword.Enabled:=false;
     eCustomLibraryName.Enabled:=false;
     eCaption.Enabled:=false;
     mDescription.Enabled:=false;

     actn_GetStandardCredentials.Enabled:=false;
     actn_MakeConnectionDefault.Enabled:=true;
     actn_TestConnection.Enabled:=true;
     actn_ReadAllFromIni.Enabled:=true;
     actn_SaveAllToIni.Enabled:=true;
     actn_SaveCurrentToIni.Enabled:=true;
   end ;

   2 : begin //Edit Mode
     cbConnectionTypes.Enabled:=true;
     eSection.Enabled:=true;
     eServer.Enabled:=true;
     eDatabasename.Enabled:=true;
     eUsername.Enabled:= true;
     ePassword.Enabled:=true;
     eCustomLibraryName.Enabled:=true;
     eCaption.Enabled:=true;
     mDescription.Enabled:=true;

     actn_GetStandardCredentials.Enabled:=true;
     actn_MakeConnectionDefault.Enabled:=false;
     actn_TestConnection.Enabled:=false;
     actn_ReadAllFromIni.Enabled:=false;
     actn_SaveAllToIni.Enabled:=false;
     actn_SaveCurrentToIni.Enabled:=false;
   end ;

  else
  //
  end;



end;

procedure TfrmCredentials.GetStandardCredentials;
var
   stdcred:TDBCredentials;
begin
  stdcred:=GetDefaultCredentials(cbConnectionTypes.Text);
  //eSection.Text:=stdcred;
  eServer.Text:=stdcred.Server;
  eDatabasename.Text:=stdcred.DatabaseName;
  eUsername.Text:=stdcred.Username;
  ePassword.Text:=stdcred.Password;
  eCustomLibraryName.Text:=stdcred.CustomLibraryName;
  eCaption.Text:=stdcred.caption;
  //mDescription.Text:=stdcred.;

end;

procedure TfrmCredentials.MakeConnectionDefault;
var
   MyIni:TIniFile;
begin
   MyIni := TIniFile.Create(FsIniFileName);
   try
   MyIni.WriteString('Standard','startdbfromsection',TConnections.FieldByName('section').AsString);
   finally
     freeandnil(MyIni);
   end;
end;

procedure TfrmCredentials.SaveAllToIni;
var
  i:integer;
begin
  TConnections.DisableControls;
  TConnections.First;
  while not TConnections.EOF do begin
    WriteCredentialsToIni(TConnections.FieldByName('section').AsString);
    TConnections.Next;
  end;
  TConnections.EnableControls;
  Application.ProcessMessages;
  WriteStandardSectionToINI;
end;

procedure TfrmCredentials.TConnectionsBeforeDelete(DataSet: TDataSet);
begin
    showmessage(esection.text);  //TODO
    DeleteCredentialFromIni(eSection.text);
    ReadIniToTConnections;
end;


function TfrmCredentials.ReadIniToTConnections: boolean;
var
  MyIni:TIniFile;
  slSections:TStringlist;
  i,j:integer;
  s,sSection,sConnectortype,sCustomLibraryname:string;
  stdCredentials:TDBCredentials;
begin
  slSections:=TStringlist.Create;

  TConnections.Clear(false);  //Clear data only, leave definitions as is
  TConnections.DisableControls;

  MyIni := TIniFile.Create(FsIniFileName);
  try
    MyIni.ReadSections(slSections);
    for i:=0 to slSections.Count -1 do
    begin
      sSection:=slSections.Strings[i];

      //Section [Standard] contains no database related settings
      if sSection='Standard' then continue;

      sConnectortype:=MyIni.ReadString(sSection,'connectortype','');
      if sConnectortype='' then showmessage('ohne connectortype gehts nicht');
      stdCredentials:=GetDefaultCredentials(sConnectortype);

      If not TConnections.Active then TConnections.Open;
      TConnections.Append;
      TConnections.FieldByName('section').AsString:=sSection;
      TConnections.FieldByName('server').AsString:=MyIni.ReadString(sSection,'server',stdCredentials.server);
      TConnections.FieldByName('databasename').AsString:=MyIni.ReadString(sSection,'databasename',stdCredentials.DatabaseName);
      TConnections.FieldByName('username').AsString:=MyIni.ReadString(sSection,'username',stdCredentials.Username);
      TConnections.FieldByName('password').AsString:=MyIni.ReadString(sSection,'password',stdCredentials.Password);
      TConnections.FieldByName('connectortype').AsString:=sConnectortype;

      s:=MyIni.ReadString(sSection,'caption','');
      if s='' then s:= sSection;
      TConnections.FieldByName('caption').AsString:=s;
      TConnections.FieldByName('description').AsString:=MyIni.ReadString(sSection,'description','');

      s:= MyIni.ReadString(sSection,'order','');
      if s='' then j:=i+1;
      TConnections.FieldByName('order').AsInteger:= j;

      sCustomLibraryname:= MyIni.ReadString(sSection,'CustomLibraryName','');
      if sCustomLibraryname='' then
          //sCustomLibraryname:=GuessLibraryLocation(sConnectortype)
      else
         begin
           //evtl eingetragene dll auf Plausibilität checken
         end;
      TConnections.FieldByName('CustomLibraryName').AsString:=sCustomLibraryname;
      TConnections.Post;

    end;  //for

    TConnections.First;
  finally
    freeandnil(MyIni);
    freeandnil(slSections);

    TConnections.EnableControls;
  end;

end;

procedure TfrmCredentials.ReadStandardSectionToControls;
var
   MyIni:TIniFile;
begin
   MyIni := TIniFile.Create(FsIniFileName);
   try
     cbImportDemoDataOnCreate.Checked:=MyIni.ReadBool('Standard','ImportDemoDataOnCreate',true);
     cbDeleteDatabasefileBeforeOpen.Checked:=MyIni.ReadBool('Standard','DeleteDatabasefileBeforeOpen',true);
     cbChooseDatabaseOnStartup.Checked:=MyIni.ReadBool('Standard','ChooseDatabaseOnStartup',false);
     cbAllowOpenDialogOnSQLImportFile.Checked:=MyIni.ReadBool('Standard','AllowOpenDialogOnSQLImportFile',false);

     eSQLCustomImportFileName.Text:=MyIni.ReadString('Standard','SQLCustomImportFileName','');
   finally
     freeandnil(MyIni);
   end;
end;

procedure TfrmCredentials.WriteStandardSectionToINI;
var
   MyIni:TIniFile;
   i:integer;
begin
   MyIni := TIniFile.Create(FsIniFileName);
   i:=20 ;
   try

     try
     MyIni.WriteBool('Standard','ImportDemoDataOnCreate',cbImportDemoDataOnCreate.Checked);
     sleep(i);
     MyIni.WriteBool('Standard','DeleteDatabasefileBeforeOpen',cbDeleteDatabasefileBeforeOpen.Checked);
     sleep(i);
     MyIni.WriteBool('Standard','ChooseDatabaseOnStartup',cbChooseDatabaseOnStartup.Checked);
     inc(i);
     MyIni.WriteBool('Standard','AllowOpenDialogOnSQLImportFile',cbAllowOpenDialogOnSQLImportFile.Checked);
     sleep(i);
     MyIni.WriteString('Standard','SQLCustomImportFileName',eSQLCustomImportFileName.Text);
     MyIni.UpdateFile;
     except
       //on E: EIniFileException do begin
       //  ShowMessage(E.Message);
       //end;
       on E:Exception do begin
         ShowMessage(E.Message + '  nach '+inttostr(i));
       end;
     end;

   finally
     freeandnil(MyIni);
   end;

end;

procedure TfrmCredentials.WriteCredentialsToIni(sSection: string);
var
   MyIni:TIniFile;
begin
  if (TConnections.State in [dsEdit, dsInsert]) then TConnections.Post;

  MyIni := TIniFile.Create(FsIniFileName);
  try
    MyIni.ReadString(sSection,'Server',TConnections.FieldByName('server').AsString);
    MyIni.ReadString(sSection,'Username',TConnections.FieldByName('username').AsString);
    MyIni.ReadString(sSection,'Password',TConnections.FieldByName('password').AsString);
    MyIni.ReadString(sSection,'DatabaseName',TConnections.FieldByName('databasename').AsString);
    MyIni.ReadString(sSection,'ConnectorType',TConnections.FieldByName('connectortype').AsString);
    MyIni.ReadString(sSection,'CustomLibraryName',TConnections.FieldByName('customlibraryname').AsString);
    MyIni.ReadString(sSection,'Caption',TConnections.FieldByName('caption').AsString);
    MyIni.ReadString(sSection,'Description',TConnections.FieldByName('description').AsString);
  finally
    freeandnil(MyIni);
  end;
end;

procedure TfrmCredentials.DeleteCredentialFromIni(sSection: string);
var
   MyIni:TIniFile;
begin
  if (TConnections.State in [dsEdit, dsInsert]) then TConnections.Post;

  MyIni := TIniFile.Create(FsIniFileName);
  try
    MyIni.EraseSection(sSection);
  finally
    freeandnil(MyIni);
  end;
end;

//*********** Actions
procedure TfrmCredentials.actn_TestConnectionExecute(Sender: TObject);
begin
  TestConnection;
end;

procedure TfrmCredentials.actn_WriteStandardSectionToINIExecute(Sender: TObject
  );
begin
  WriteStandardSectionToINI;
end;

procedure TfrmCredentials.actn_ReadAllFromIniExecute(Sender: TObject);
begin
  ReadIniToTConnections;
end;

procedure TfrmCredentials.actn_ReadStandardSectionToControlsExecute(
  Sender: TObject);
begin
  ReadStandardSectionToControls;
end;

procedure TfrmCredentials.actn_SaveAllToIniExecute(Sender: TObject);
begin
  SaveAllToIni;
end;

procedure TfrmCredentials.actn_SaveCurrentToIniExecute(Sender: TObject);
begin
  WriteCredentialsToIni(eSection.text);
end;

procedure TfrmCredentials.actn_MakeConnectionDefaultExecute(Sender: TObject);
begin
  MakeConnectionDefault;
end;

procedure TfrmCredentials.actn_GetStandardCredentialsExecute(Sender: TObject);
begin
  GetStandardCredentials;
end;

end.

